"""
Implement Q-learning with linear function approximation
"""
import numpy as np
from matplotlib import pyplot as plt
from cartpole_cs292 import CartPoleEnv


def policy_evaluation(policy, num_episode=1000, episode_length=200):
    """
    On-policy evaluation of the policy

    :param policy: policy to be evaluated
    :param num_episode: number of episodes
    :param episode_length: max horizon of the episode (max steps)
    :return: total_reward_list: np.array(num_episode)
        total reward for each episode
    """
    total_reward_list = np.zeros(num_episode)
    for epoch in range(num_episode):
        observation = env.reset()
        total_reward = 0
        for iter in range(episode_length):
            ############################
            # YOUR IMPLEMENTATION HERE #

            ############################
            pass
        total_reward_list[epoch] = total_reward
        env.close()
    return total_reward_list


def feature_map(obs):
    """
    Get the feature map phi(s)

    :param obs: observation
    :return: feature: np.array(21) 1D array
    """
    clip_range = np.array([2.4, 5.0, 0.418, 1.0])
    obs = obs / clip_range
    # nonlinear expansion
    phi = np.concatenate([obs, np.kron(obs, obs)])
    phi = np.append(1, phi)
    return phi


def policy(obs):
    """
    Select the greedy action according to a given Q1 and Q2 value function

    :param obs: observation
    :return: action value: int
    """
    ############################
    # YOUR IMPLEMENTATION HERE #

    ############################
    pass


def Update_Q(obs, a, r, obs_prime, lr=0.2, gamma=0.99):
    """
    Update the Q1 value matrix and Q2 value matrix

    :param obs: observation
    :param a: action
    :param r: reward
    :param obs_prime: next state (observation)
    :param lr: learning rate
    :param gamma: discounted value
    """
    global Q1, Q2
    ############################
    # YOUR IMPLEMENTATION HERE #

    ############################
    pass


def q_learning_linear():
    """
    Implement Q-learning

    :return: None
    """
    # set parameters of learning
    num_episode = 400
    learning_rate = 0.01
    gamma = 1.0
    episode_length = 200
    epsilon = 1
    epsilon_decay = 0.999

    expected_reward_list = []
    for epoch in range(num_episode):
        total_reward = 0
        observation = env.reset()
        for iter in range(episode_length):
            ############################
            # YOUR IMPLEMENTATION HERE #

            ############################
            pass

        print('Episode ', epoch, ', Total reward =', total_reward, ', epsilon =', epsilon)
        epsilon = epsilon * epsilon_decay
        env.close()

        if epoch % 50 == 0:
            reward_list = policy_evaluation(policy, num_episode=400)
            expected_reward_list.append(np.mean(reward_list))

    plt.plot(np.arange(1, num_episode + 1, 50), expected_reward_list)
    plt.xlabel('Episode')
    plt.ylabel('Reward')
    plt.show()
    plt.close()


if __name__ == '__main__':
    env = CartPoleEnv()
    # Q1 and Q2 value function
    Q1 = np.zeros(shape=[21])
    Q2 = np.zeros(shape=[21])

    # run q_learning with linear function approximation
    q_learning_linear()

    policy_evaluation(policy, num_episode=10, test=True)
